;****************************************************************************
; Program		: Port Output 01
; Description	: LED Running End-to-End
; For			: NX-51 Version 2.0 (Philips P89C51RD2)
;				: MCS-51 Microcontroller Training System
; Filename		: E1101.ASM
; Assembler		: RAD51
; Copyright (C) 2000 Innovative Experiment Co.,Ltd.
;****************************************************************************

;----------------------------------------------------------------------------
; Define Port&Pin Name
;----------------------------------------------------------------------------
DRIVER_LE		BIT		P1.4	; Driver Latch Enable (Active High : Level)

;----------------------------------------------------------------------------
; Main Program.
;----------------------------------------------------------------------------

				ORG		0000H			; Reset Vector
										; Initial all port for NX-51 V.2.0
				MOV		P0,#00000000B	; Clear Databus
				MOV		P1,#11101111B	; Clear status all devices
				MOV		P2,#11111111B   ; Free Keypad input and onewire
				MOV		P3,#00011111B	; Clear status LCD, R-2R, P3.2-3.4

				SETB	DRIVER_LE		; Enable Driver Latch

MAIN:			MOV		R0,#7			; Set 7 times loop
				MOV		A,#00000001B	; Initial ACC. Value

LOOP_LEFT:		MOV		P0,A			; Out ACC. Value to DATABUS
				ACALL	DELAY_1s		; Delay 1 s
				RL		A				; Rotate ACC. Left
				DJNZ	R0,LOOP_LEFT	; Do loop until 7 times

				MOV		R0,#7			; Set 7 times loop

LOOP_RIGHT:		MOV		P0,A			; Out ACC. Value to DATABUS
				ACALL	DELAY_1s		; Delay 1 s
				RR		A				; Rotate ACC. Right
				DJNZ	R0,LOOP_RIGHT	; Do loop until 7 times

				AJMP	MAIN			; Jump to Main

;----------------------------------------------------------------------------
; Dummy Delay time 10ms,1s
;----------------------------------------------------------------------------
DELAY_10ms:		MOV		R7,#010			; Do 10 times
DELAY_10ms_1:	MOV		R6,#0E6H		; Each loop = 1 ms
DELAY_10ms_2:	NOP
				NOP

				; P89C51RD2 addition
				NOP
				NOP
				NOP
				NOP
				; End

				DJNZ	R6,DELAY_10ms_2
				DJNZ	R7,DELAY_10ms_1
				RET

DELAY_1s:		MOV		R5,#100			; Do 100 times
DELAY_1s_1:		ACALL	DELAY_10ms
				DJNZ	R5,DELAY_1s_1
				RET
