;****************************************************************************
; Program		: 7 Segment 01
; Description	: 7 Segment output < Direct drive digit >
; For			: NX-51 Version 2.0 (Philips P89C51RD+)
;				: MCS-51 Microcontroller Training System
;
; NX-51 V2 NOTE : P1 Function switch must be in PORT1 mode
;
; Filename		: E1301.ASM
; Assembler		: RAD51
; Copyright (C) 2000 Innovative Experiment Co.,Ltd.
;****************************************************************************

;----------------------------------------------------------------------------
; Define Port&Pin Name
;----------------------------------------------------------------------------
DSP1			BIT		P1.2	; 7 Segment DSP1 enable (Active Low : Level)
DSP2			BIT		P1.3	; 7 Segment DSP2 enable (Active Low : Level)

;----------------------------------------------------------------------------
;Define Constant
;----------------------------------------------------------------------------
;				Segment .GFEDCBA
DSP_NUM0		EQU		00111111B
DSP_NUM1		EQU		00000110B
DSP_NUM2		EQU		01011011B
DSP_NUM3		EQU		01001111B
DSP_NUM4		EQU		01100110B
DSP_NUM5		EQU		01101101B
DSP_NUM6		EQU		01111101B
DSP_NUM7		EQU		00000111B
DSP_NUM8		EQU		01111111B
DSP_NUM9		EQU		01101111B
DSP_NUMA		EQU		01110111B
DSP_NUMB		EQU		01111100B
DSP_NUMC		EQU		00111001B
DSP_NUMD		EQU		01011110B
DSP_NUME		EQU		01111001B
DSP_NUMF		EQU		01110001B

;----------------------------------------------------------------------------
; Main Program.
;----------------------------------------------------------------------------

				ORG		0000H			; Reset Vector
										; Initial all port for NX-51 V.2.0
				MOV		P0,#00000000B	; Clear Databus
				MOV		P1,#11101111B	; Clear status all devices
				MOV		P2,#11111111B   ; Free Keypad input and onewire
				MOV		P3,#00011111B	; Clear status LCD, R-2R, P3.2-3.4

MAIN:			CLR		DSP1			; Initial DSP 1 is Show Before
				SETB	DSP2

LOOP:			MOV		P0,#DSP_NUM0	; Out Digit 0
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM1	; Out Digit 1
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM2	; Out Digit 2
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM3	; Out Digit 3
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM4	; Out Digit 4
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM5	; Out Digit 5
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM6	; Out Digit 6
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM7	; Out Digit 7
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM8	; Out Digit 8
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUM9	; Out Digit 9
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUMA	; Out Digit A
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUMB	; Out Digit B
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUMC	; Out Digit C
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUMD	; Out Digit D
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUME	; Out Digit E
				ACALL		DELAY_500ms
				MOV		P0,#DSP_NUMF	; Out Digit F
				ACALL		DELAY_500ms

				MOV		R4,#2			; Set loop 2 times
BLINK_DOT:		SETB	P0.7			; Blink Dot Point
				ACALL	DELAY_250ms
				CLR		P0.7
				ACALL	DELAY_250ms
				DJNZ	R4,BLINK_DOT	; Do until 2 times

				CPL		DSP1			; Complement DIGIT
				CPL		DSP2			;

				AJMP	LOOP

;----------------------------------------------------------------------------
; Dummy Delay time 250ms,500ms
;----------------------------------------------------------------------------
DELAY_250ms:	MOV		R7,#250			; Do 250 times
DELAY_250ms_1:	MOV		R6,#0E6H		; Each loop = 1 ms
DELAY_250ms_2:	NOP
				NOP

				; P89C51RD2 addition
				NOP
				NOP
				NOP
				NOP
				; End

				DJNZ	R6,DELAY_250ms_2
				DJNZ	R7,DELAY_250ms_1
				RET

DELAY_500ms:	MOV		R5,#2			; Do 2 times
DELAY_500ms_1:	ACALL	DELAY_250ms
				DJNZ	R5,DELAY_500ms_1
				RET