;****************************************************************************
; Program		: Timer 01
; Description	: Square Wave Generator 500Hz on T0 pin (P3.4)
; For			: NX-51 Version 2.0 (Philips P89C51RD2)
;				: MCS-51 Microcontroller Training System
; Filename		: E2301.ASM
; Assembler		: RAD51
; Copyright (C) 2000 Innovative Experiment Co.,Ltd.
;****************************************************************************

;----------------------------------------------------------------------------
; Define Port&Pin Name
;----------------------------------------------------------------------------
T0_PIN			BIT		P3.4		; Timer/Counter 0 PIN

;----------------------------------------------------------------------------
; Main Program.
;----------------------------------------------------------------------------

				ORG		0000H			; Reset Vector
				AJMP	MAIN			; Jump to Main

				ORG		0003H			; IE0 Vector
				RETI					; Return interrupt

				ORG		000BH			; TF0 Vector
				MOV		TH0,#0F8H		; 1 ms Interval Time
				MOV		TL0,#0CDH		;
				CPL		T0_PIN			;
				RETI					; Return interrupt
				
				ORG		0013H			; IE1 Vector
				RETI					; Return interrupt

				ORG		001BH			; TF1 Vector
				RETI					; Return interrupt

				ORG		0023H			; TI+RI Vector
				RETI					; Return interrupt

				ORG		002BH			; TF2+EXF2 Vector
				RETI					; Return interrupt

MAIN:									; Initial all port for NX-51 V.2.0
				MOV		P0,#00000000B	; Clear Databus
				MOV		P1,#11101111B	; Clear status all devices
				MOV		P2,#11111111B   ; Free Keypad input and onewire
				MOV		P3,#00011111B	; Clear status LCD, R-2R, P3.2-3.4

				MOV		TMOD,#021H		; T1 8Bit Auto, T0 16Bit
				MOV		TH0,#0F8H		; 1 ms Interval Time
				MOV		TL0,#0CDH		;

				MOV		IE,#10000010B	; En. EA,ET0

				SETB	TR0				; Start Timer 0
				AJMP	$				; Jump to Main loop